import type React from 'react';
import type { FormInstance } from 'antd';
import type { ActionTypeText, RecordKey, RowEditableConfig } from '../useEditableArray';
export declare type AddLineOptions = {
    position?: 'top' | 'bottom';
    recordKey?: React.Key;
};
/**
 * 一个方便的hooks 用于维护编辑的状态
 *
 * @param props
 */
declare function useEditableMap<RecordType>(props: RowEditableConfig<RecordType> & {
    dataSource: RecordType;
    childrenColumnName: string | undefined;
    setDataSource: (dataSource: RecordType) => void;
}): {
    editableKeys: React.Key[];
    setEditableRowKeys: (value: React.Key[], ignoreDestroy?: boolean | undefined) => void;
    isEditable: (recordKey: RecordKey) => boolean;
    actionRender: (key: RecordKey, form: FormInstance<any>, config?: ActionTypeText<RecordType> | undefined) => React.ReactNode[] | (JSX.Element | null)[];
    startEditable: (recordKey: RecordKey) => boolean;
    cancelEditable: (recordKey: RecordKey) => boolean;
};
export declare type UseEditableMapType = typeof useEditableMap;
export declare type UseEditableMapUtilType = ReturnType<UseEditableMapType>;
export default useEditableMap;
