import type { NamePath } from 'antd/lib/form/interface';
import moment from 'moment';
import type { ProFieldValueType } from '../typing';
declare type DateFormatter = 'number' | 'string' | ((value: moment.Moment, valueType: string) => string | number) | false;
export declare const dateFormatterMap: {
    time: string;
    timeRange: string;
    date: string;
    dateWeek: string;
    dateMonth: string;
    dateQuarter: string;
    dateYear: string;
    dateRange: string;
    dateTime: string;
    dateTimeRange: string;
};
export declare function isPlainObject(o: {
    constructor: any;
}): boolean;
/**
 * 根据不同的格式转化 moment
 *
 * @param value
 * @param dateFormatter
 * @param valueType
 */
export declare const convertMoment: (value: moment.Moment, dateFormatter: string | false | ((value: moment.Moment, valueType: string) => string | number), valueType: string) => string | number | moment.Moment;
/**
 * 这里主要是来转化一下数据 将 moment 转化为 string 将 all 默认删除
 *
 * @param value
 * @param dateFormatter
 * @param proColumnsMap
 */
declare const conversionMomentValue: <T = any>(value: T, dateFormatter: DateFormatter, valueTypeMap: Record<string, {
    valueType: ProFieldValueType;
    dateFormat: string;
} | any>, omitNil?: boolean | undefined, parentKey?: NamePath | undefined) => T;
export default conversionMomentValue;
