"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _useMergedState3 = _interopRequireDefault(require("rc-util/lib/hooks/useMergedState"));

var _react = require("react");

function useMountMergeState(initialState, option) {
  var mountRef = (0, _react.useRef)(false);
  var frame = (0, _react.useRef)(undefined);
  (0, _react.useEffect)(function () {
    mountRef.current = true;
    return function () {
      clearTimeout(frame.current);
      mountRef.current = false;
    };
  }, []);

  var _useMergedState = (0, _useMergedState3.default)(initialState, option),
      _useMergedState2 = (0, _slicedToArray2.default)(_useMergedState, 2),
      state = _useMergedState2[0],
      setState = _useMergedState2[1];

  var mountSetState = function mountSetState(prevState) {
    clearTimeout(frame.current);
    frame.current = window.setTimeout(function () {
      if (mountRef.current) {
        setState(prevState);
      }
    }, 16);
  };

  return [state, mountSetState];
}

var _default = useMountMergeState;
exports.default = _default;